# -*- coding: utf-8 -*-

import sys
import types
import PyQt5.QtCore as core
import PyQt5.QtGui as gui
import PyQt5.QtWidgets as widgets
import PyQt5.uic as uic

app = widgets.QApplication(sys.argv)
w = uic.loadUi("pinch.ui")
img = gui.QImage("test.png")
painter = gui.QPainter()
transformHistory = gui.QTransform()
transformTotal = gui.QTransform()
startPoint = core.QPoint()

def handleEvents(self, event):
    global transformHistory, transformTotal, startPoint
    if event.type() == core.QEvent.Gesture:
        g = event.gesture(core.Qt.PinchGesture)
        if g != None:
            upperLeft = self.mapToGlobal(core.QPoint())
            scale = g.totalScaleFactor()
            angle = g.totalRotationAngle()
            centerPoint = g.centerPoint() - upperLeft
            if g.state() == core.Qt.GestureStarted:
                startPoint = g.centerPoint() - upperLeft
            transformTotal = transformHistory * gui.QTransform().translate(centerPoint.x(), centerPoint.y()).rotate(angle).scale(scale, scale).translate(-startPoint.x(), -startPoint.y())
            if g.state() == core.Qt.GestureFinished:
                transformHistory = transformTotal
            self.update()
        else:
            g = event.gesture(core.Qt.TapGesture)
            if g.state() == core.Qt.GestureFinished:
                print("tap ", g.position())
                transformTotal = gui.QTransform()
                transformHistory = gui.QTransform()
                self.update()
    elif event.type() == core.QEvent.Paint:
        painter.begin(self)
        painter.setTransform(transformTotal)
        painter.drawImage(0, 0, img)
        painter.end()
    return True

w.widget.event = types.MethodType(handleEvents, w.widget)
w.widget.grabGesture(core.Qt.PinchGesture)
w.widget.grabGesture(core.Qt.TapGesture)
w.show()
sys.exit(app.exec_())